<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: HttpServer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">HttpServer.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * HttpServer.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Aug 30, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * Implementation of an HTTP server for the ESP32.</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_HTTPSERVER_H_</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_HTTPSERVER_H_</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;SockServ.h&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;HttpRequest.h&quot;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;HttpResponse.h&quot;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &quot;FreeRTOS.h&quot;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;regex&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">class </span><a class="code" href="classHttpServerTask.html">HttpServerTask</a>;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="classPathHandler.html">   27</a></span>&#160;<span class="keyword">class </span><a class="code" href="classPathHandler.html">PathHandler</a> {</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <a class="code" href="classPathHandler.html#a2fd73ffd5f17f9a0de2f8bd89b4437c2">PathHandler</a>(</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;            std::string method,                <span class="comment">// The method in the request to be matched.</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;            std::string pathPattern,           <span class="comment">// The pattern in the request to be matched</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            <span class="keywordtype">void</span> (*pWebServerRequestHandler)   <span class="comment">// The handler function to be invoked upon a match.</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;            (</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;                <a class="code" href="classHttpRequest.html">HttpRequest</a>*  pHttpRequest,</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;                <a class="code" href="classHttpResponse.html">HttpResponse</a>* pHttpResponse)</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;            );</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <a class="code" href="classPathHandler.html#a2fd73ffd5f17f9a0de2f8bd89b4437c2">PathHandler</a>(</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;            std::string method,                <span class="comment">// The method in the request to be matched.</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;            std::regex* pathPattern,           <span class="comment">// The pattern in the request to be matched (regex)</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;            <span class="keywordtype">void</span> (*pWebServerRequestHandler)   <span class="comment">// The handler function to be invoked upon a match.</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;            (</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;                <a class="code" href="classHttpRequest.html">HttpRequest</a>*  pHttpRequest,</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;                <a class="code" href="classHttpResponse.html">HttpResponse</a>* pHttpResponse)</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            );</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classPathHandler.html#a5a50a3baba682292270f79b3a435cc4c">match</a>(std::string method, std::string path);   <span class="comment">// Does the request method and pattern match?</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classPathHandler.html#ae5f06052f99f675aef8ccea42b7cd09f">invokePathHandler</a>(<a class="code" href="classHttpRequest.html">HttpRequest</a>* request, <a class="code" href="classHttpResponse.html">HttpResponse</a>* response);</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        std::string m_method;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        std::regex* m_pRegex;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keywordtype">bool</span>        m_isRegex;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        std::string m_textPattern;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        void (*m_pRequestHandler)(<a class="code" href="classHttpRequest.html">HttpRequest</a>* pHttpRequest, <a class="code" href="classHttpResponse.html">HttpResponse</a>* pHttpResponse);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;}; <span class="comment">// PathHandler</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="classHttpServer.html">   56</a></span>&#160;<span class="keyword">class </span><a class="code" href="classHttpServer.html">HttpServer</a> {</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <a class="code" href="classHttpServer.html#a303273c5e6469b4ea4277668cd86ec67">HttpServer</a>();</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classHttpServer.html">HttpServer</a>();</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordtype">void</span>        <a class="code" href="classHttpServer.html#aac086f847e37748c0c54f1e295baf2e4">addPathHandler</a>(</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        std::string method,</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        std::string pathExpr,</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keywordtype">void</span> (*webServerRequestHandler)</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        (</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            <a class="code" href="classHttpRequest.html">HttpRequest</a>*  pHttpRequest,</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            <a class="code" href="classHttpResponse.html">HttpResponse</a>* pHttpResponse)</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        );</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordtype">void</span>        <a class="code" href="classHttpServer.html#aac086f847e37748c0c54f1e295baf2e4">addPathHandler</a>(</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        std::string method,</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        std::regex* pRegex,</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordtype">void</span> (*webServerRequestHandler)</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        (</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            <a class="code" href="classHttpRequest.html">HttpRequest</a>*  pHttpRequest,</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            <a class="code" href="classHttpResponse.html">HttpResponse</a>* pHttpResponse)</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        );</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    uint32_t    <a class="code" href="classHttpServer.html#a284988ba72075a9abc3af5499ed9ed56">getClientTimeout</a>();                         <span class="comment">// Get client&#39;s socket timeout</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keywordtype">size_t</span>      <a class="code" href="classHttpServer.html#ac771b9fe9b2d825df7231ff0dee7e253">getFileBufferSize</a>();  <span class="comment">// Get the current size of the file buffer.</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    uint16_t    <a class="code" href="classHttpServer.html#af4a61a2ac8da8773025da0d2fde1aef5">getPort</a>();            <span class="comment">// Get the port on which the Http server is listening.</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    std::string <a class="code" href="classHttpServer.html#aa4dfccf48a9c721ca8bb00d61f7b4e13">getRootPath</a>();        <span class="comment">// Get the root of the file system path.</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="keywordtype">bool</span>        <a class="code" href="classHttpServer.html#ad3d17b4df0252445a2ed4f0f8ea06201">getSSL</a>();             <span class="comment">// Are we using SSL?</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="keywordtype">void</span>        <a class="code" href="classHttpServer.html#ad70784b8f9484a16bf74c34413a24d4d">setClientTimeout</a>(uint32_t timeout);            <span class="comment">// Set client&#39;s socket timeout</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordtype">void</span>        <a class="code" href="classHttpServer.html#aab1f060cbbaaeaa2b75f812e866e6ff0">setDirectoryListing</a>(<span class="keywordtype">bool</span> use);             <span class="comment">// Should we list the content of directories?</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keywordtype">void</span>        <a class="code" href="classHttpServer.html#a7686343c224f5e8a62f5f07de481345d">setFileBufferSize</a>(<span class="keywordtype">size_t</span> fileBufferSize);  <span class="comment">// Set the size of the file buffer</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keywordtype">void</span>        <a class="code" href="classHttpServer.html#a141a7cde0ccf11ff395df0faef79d6a5">setRootPath</a>(std::string path);             <span class="comment">// Set the root of the file system path.</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="keywordtype">void</span>        <a class="code" href="classHttpServer.html#a79bbf11522346b2eae709e6112b130c2">start</a>(uint16_t portNumber, <span class="keywordtype">bool</span> useSSL = <span class="keyword">false</span>);</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keywordtype">void</span>        <a class="code" href="classHttpServer.html#aad9c63d3f8cda248e3c87067ac3ac5a5">stop</a>();          <span class="comment">// Stop a previously started server.</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classHttpServerTask.html">HttpServerTask</a>;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classWebSocket.html">WebSocket</a>;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordtype">void</span>                     listDirectory(std::string path, <a class="code" href="classHttpResponse.html">HttpResponse</a>&amp; response);</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="keywordtype">size_t</span>                   m_fileBufferSize;     <span class="comment">// Size of the file buffer.</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keywordtype">bool</span>                     m_directoryListing;   <span class="comment">// Should we list directory content?</span></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    std::vector&lt;PathHandler&gt; m_pathHandlers;       <span class="comment">// Vector of path handlers.</span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    uint16_t                 m_portNumber;         <span class="comment">// Port number on which server is listening.</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    std::string              m_rootPath;           <span class="comment">// Root path into the file system.</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <a class="code" href="classSocket.html">Socket</a>                   m_socket;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="keywordtype">bool</span>                     m_useSSL;             <span class="comment">// Is this server listening on an HTTPS port?</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    uint32_t                 m_clientTimeout;      <span class="comment">// Default Timeout</span></div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>      m_semaphoreServerStarted = <a class="code" href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a>(<span class="stringliteral">&quot;ServerStarted&quot;</span>);</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;}; <span class="comment">// HttpServer</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_HTTPSERVER_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classSocket_html"><div class="ttname"><a href="classSocket.html">Socket</a></div><div class="ttdoc">Encapsulate a socket.</div><div class="ttdef"><b>Definition:</b> Socket.h:62</div></div>
<div class="ttc" id="classHttpServer_html_aac086f847e37748c0c54f1e295baf2e4"><div class="ttname"><a href="classHttpServer.html#aac086f847e37748c0c54f1e295baf2e4">HttpServer::addPathHandler</a></div><div class="ttdeci">void addPathHandler(std::string method, std::string pathExpr, void(*webServerRequestHandler)(HttpRequest *pHttpRequest, HttpResponse *pHttpResponse))</div><div class="ttdoc">Register a handler for a path.</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:215</div></div>
<div class="ttc" id="classHttpServer_html_aa4dfccf48a9c721ca8bb00d61f7b4e13"><div class="ttname"><a href="classHttpServer.html#aa4dfccf48a9c721ca8bb00d61f7b4e13">HttpServer::getRootPath</a></div><div class="ttdeci">std::string getRootPath()</div><div class="ttdoc">Get the current root path.</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:250</div></div>
<div class="ttc" id="classPathHandler_html"><div class="ttname"><a href="classPathHandler.html">PathHandler</a></div><div class="ttdoc">Handle path matching for an incoming HTTP request.</div><div class="ttdef"><b>Definition:</b> HttpServer.h:27</div></div>
<div class="ttc" id="classHttpServer_html_ad3d17b4df0252445a2ed4f0f8ea06201"><div class="ttname"><a href="classHttpServer.html#ad3d17b4df0252445a2ed4f0f8ea06201">HttpServer::getSSL</a></div><div class="ttdeci">bool getSSL()</div><div class="ttdoc">Return whether or not we are using SSL.</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:259</div></div>
<div class="ttc" id="classHttpServer_html_a303273c5e6469b4ea4277668cd86ec67"><div class="ttname"><a href="classHttpServer.html#a303273c5e6469b4ea4277668cd86ec67">HttpServer::HttpServer</a></div><div class="ttdeci">HttpServer()</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:32</div></div>
<div class="ttc" id="classHttpServer_html_af4a61a2ac8da8773025da0d2fde1aef5"><div class="ttname"><a href="classHttpServer.html#af4a61a2ac8da8773025da0d2fde1aef5">HttpServer::getPort</a></div><div class="ttdeci">uint16_t getPort()</div><div class="ttdoc">Get the port number on which the HTTP Server is listening.</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:241</div></div>
<div class="ttc" id="classHttpServer_html_a141a7cde0ccf11ff395df0faef79d6a5"><div class="ttname"><a href="classHttpServer.html#a141a7cde0ccf11ff395df0faef79d6a5">HttpServer::setRootPath</a></div><div class="ttdeci">void setRootPath(std::string path)</div><div class="ttdoc">Set the root path for URL file mapping.</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:371</div></div>
<div class="ttc" id="classHttpServer_html_aad9c63d3f8cda248e3c87067ac3ac5a5"><div class="ttname"><a href="classHttpServer.html#aad9c63d3f8cda248e3c87067ac3ac5a5">HttpServer::stop</a></div><div class="ttdeci">void stop()</div><div class="ttdoc">Shutdown the HTTP server.</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:412</div></div>
<div class="ttc" id="classHttpServer_html_a79bbf11522346b2eae709e6112b130c2"><div class="ttname"><a href="classHttpServer.html#a79bbf11522346b2eae709e6112b130c2">HttpServer::start</a></div><div class="ttdeci">void start(uint16_t portNumber, bool useSSL=false)</div><div class="ttdoc">Start the HTTP server listening. We start an instance of the HTTP server listening....</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:388</div></div>
<div class="ttc" id="classPathHandler_html_a5a50a3baba682292270f79b3a435cc4c"><div class="ttname"><a href="classPathHandler.html#a5a50a3baba682292270f79b3a435cc4c">PathHandler::match</a></div><div class="ttdeci">bool match(std::string method, std::string path)</div><div class="ttdoc">Determine if the path matches.</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:472</div></div>
<div class="ttc" id="classWebSocket_html"><div class="ttname"><a href="classWebSocket.html">WebSocket</a></div><div class="ttdef"><b>Definition:</b> WebSocket.h:60</div></div>
<div class="ttc" id="classHttpServer_html_ad70784b8f9484a16bf74c34413a24d4d"><div class="ttname"><a href="classHttpServer.html#ad70784b8f9484a16bf74c34413a24d4d">HttpServer::setClientTimeout</a></div><div class="ttdeci">void setClientTimeout(uint32_t timeout)</div><div class="ttdoc">Set different socket timeout for new connections.</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:319</div></div>
<div class="ttc" id="classPathHandler_html_a2fd73ffd5f17f9a0de2f8bd89b4437c2"><div class="ttname"><a href="classPathHandler.html#a2fd73ffd5f17f9a0de2f8bd89b4437c2">PathHandler::PathHandler</a></div><div class="ttdeci">PathHandler(std::string method, std::string pathPattern, void(*pWebServerRequestHandler)(HttpRequest *pHttpRequest, HttpResponse *pHttpResponse))</div><div class="ttdoc">Construct an instance of a PathHandler.</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:451</div></div>
<div class="ttc" id="classHttpServer_html"><div class="ttname"><a href="classHttpServer.html">HttpServer</a></div><div class="ttdef"><b>Definition:</b> HttpServer.h:56</div></div>
<div class="ttc" id="classHttpServerTask_html"><div class="ttname"><a href="classHttpServerTask.html">HttpServerTask</a></div><div class="ttdoc">Be an HTTP server task. Here we define a Task that will be run when the HTTP server starts....</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:53</div></div>
<div class="ttc" id="classHttpServer_html_ac771b9fe9b2d825df7231ff0dee7e253"><div class="ttname"><a href="classHttpServer.html#ac771b9fe9b2d825df7231ff0dee7e253">HttpServer::getFileBufferSize</a></div><div class="ttdeci">size_t getFileBufferSize()</div><div class="ttdoc">Get the size of the file buffer. When serving up a file from the file system, we can't afford to read...</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:232</div></div>
<div class="ttc" id="classHttpServer_html_a284988ba72075a9abc3af5499ed9ed56"><div class="ttname"><a href="classHttpServer.html#a284988ba72075a9abc3af5499ed9ed56">HttpServer::getClientTimeout</a></div><div class="ttdeci">uint32_t getClientTimeout()</div><div class="ttdoc">Get current socket's timeout for new connections.</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:328</div></div>
<div class="ttc" id="classHttpRequest_html"><div class="ttname"><a href="classHttpRequest.html">HttpRequest</a></div><div class="ttdef"><b>Definition:</b> HttpRequest.h:19</div></div>
<div class="ttc" id="classFreeRTOS_1_1Semaphore_html"><div class="ttname"><a href="classFreeRTOS_1_1Semaphore.html">FreeRTOS::Semaphore</a></div><div class="ttdef"><b>Definition:</b> FreeRTOS.h:31</div></div>
<div class="ttc" id="classPathHandler_html_ae5f06052f99f675aef8ccea42b7cd09f"><div class="ttname"><a href="classPathHandler.html#ae5f06052f99f675aef8ccea42b7cd09f">PathHandler::invokePathHandler</a></div><div class="ttdeci">void invokePathHandler(HttpRequest *request, HttpResponse *response)</div><div class="ttdoc">Invoke the handler.</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:489</div></div>
<div class="ttc" id="classHttpServer_html_aab1f060cbbaaeaa2b75f812e866e6ff0"><div class="ttname"><a href="classHttpServer.html#aab1f060cbbaaeaa2b75f812e866e6ff0">HttpServer::setDirectoryListing</a></div><div class="ttdeci">void setDirectoryListing(bool use)</div><div class="ttdoc">Set whether or not we will list directories.</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:337</div></div>
<div class="ttc" id="classHttpServer_html_a7686343c224f5e8a62f5f07de481345d"><div class="ttname"><a href="classHttpServer.html#a7686343c224f5e8a62f5f07de481345d">HttpServer::setFileBufferSize</a></div><div class="ttdeci">void setFileBufferSize(size_t fileBufferSize)</div><div class="ttdoc">Set the size of the file buffer. When serving up a file from the file system, we can't afford to read...</div><div class="ttdef"><b>Definition:</b> HttpServer.cpp:349</div></div>
<div class="ttc" id="classHttpResponse_html"><div class="ttname"><a href="classHttpResponse.html">HttpResponse</a></div><div class="ttdef"><b>Definition:</b> HttpResponse.h:16</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
